﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Threading;

namespace IncorrectCombinationOfMutexAndMonitor {
	class Program {
		static void Main(string[] args) {

			var m = new Mutex();

			var t = new Thread(() => {
				Thread.Sleep(100);
				Console.WriteLine("T2: before critical section");
				m.WaitOne();
				{
					Console.WriteLine("T2: entered critical section (Mutex.WaitOne), sleeping ...");
					Thread.Sleep(2500);
					Console.WriteLine("T2: leaving critical section (Mutex.RelaseMutex) ...");
				}
				m.ReleaseMutex();
				Console.WriteLine("T2: after critical section");
			});
			t.Start();

			Console.WriteLine("Main: before critical section");
			lock (m) {	// Locking "default" lock, and NOT the Mutex!
				Console.WriteLine("Main: entered critical section (Monitor.Enter), sleeping ...");
				Thread.Sleep(2500);
				Console.WriteLine("Main: leaving critical section (Monitor.Exit) ...");
			}
			Console.WriteLine("Main: after critical section");

			t.Join();
		}
	}
}
